<template>
  <section class="AppSystemAccount">
    <ai-list>
      <ai-title slot="title" title="账号管理" isShowBottomBorder/>
      <template #content>
        <ai-search-bar>
          <template #left>
            <el-button type="primary" icon="iconfont iconAdd" @click="dialog=true">添加</el-button>
<!--            <el-button type="primary" :disabled="!ids.toString()" @click="batchAllot">功能分配</el-button>-->
          </template>
          <template #right>
            <el-input size="small" placeholder="搜索姓名、手机号" v-model="search.condition" clearable
                      @change="page.pageNum=1,getTableData()"/>
          </template>
        </ai-search-bar>
        <ai-table :tableData="tableData" :total="page.total" :current.sync="page.pageNum" :size.sync="page.pageSize"
                  @getList="getTableData" :col-configs="colConfigs" :dict="dict"
                  @selection-change="v=>ids=v.map(e=>e.id)">
          <el-table-column slot="name" label="姓名" width="180px">
            <el-row type="flex" align="middle" slot-scope="{row}">
              <el-image class="avatar" :src="row.avatar" :preview-src-list="[row.avatar]">
                <el-image slot="error" src="https://cdn.cunwuyun.cn/dvcp/h5/defaultAvatar.png" alt=""/>
              </el-image>
              <div>{{ row.name }}</div>
            </el-row>
          </el-table-column>
          <el-table-column slot="options" align="center" label="操作" fixed="right" width="160px">
            <el-row type="flex" justify="center" align="middle" slot-scope="{row}">
              <el-button type="text" @click="appAllot(row)">功能分配</el-button>
              <el-button type="text" @click="handleDelete(row.id)">删除</el-button>
            </el-row>
          </el-table-column>
        </ai-table>
      </template>
    </ai-list>
    <!--添加账号、功能分配-->
    <ai-dialog :title="dialogTitle" :visible.sync="dialog" width="600px" @open="initDialogData"
               @onConfirm="updateAccount" @closed="dialogForm={}">
      <el-form ref="updateAccountForm" :model="dialogForm" :rules="rules" size="small"
               label-width="120px">
        <el-form-item required label="姓名" prop="name">
          <el-input v-model.trim="dialogForm.name" placeholder="请输入..." clearable
                    :maxLength="15"/>
        </el-form-item>
        <el-form-item required label="手机号码" prop="phone">
          <el-input v-model.trim="dialogForm.phone" placeholder="请输入..." clearable
                    :maxLength="11" :disabled="isEdit"/>
        </el-form-item>
        <el-form-item required label="角色" prop="roleId">
          <el-select size="small" placeholder="请选择角色" :value="dialogForm.roleId" filterable
                     v-model="dialogForm.roleId" clearable>
            <el-option v-for="(op,i) in accountRoles" :key="i" :label="op.name" :value="op.id"/>
          </el-select>
        </el-form-item>
        <el-form-item label="行政地区" prop="areaId">
          <ai-area-get v-model="dialogForm.areaId" :instance="instance" @select="handleAreaSelect"/>
        </el-form-item>
      </el-form>
    </ai-dialog>
  </section>
</template>

<script>
import {mapState} from "vuex";

export default {
  name: "AppSystemAccount",
  label: "账号管理",
  props: {
    instance: Function,
    dict: Object,
    permissions: Function
  },
  computed: {
    ...mapState(['user']),
    cascaderProps() {
      return {
        value: 'id',
        checkStrictly: true,
        emitPath: false
      }
    },
    isEdit() {
      return !!this.dialogForm.id
    },
    dialogTitle() {
      return this.isEdit ? '功能分配' : '添加账号'
    },
    colConfigs() {
      return [
        // {type: 'selection', align: 'center'},
        {label: "姓名", slot: "name"},
        {label: "联系方式", prop: "phone", align: 'center'},
        {label: "角色", prop: "roleName", align: 'center'},
        {label: "地区", prop: "areaName"},
        {slot: "options"}
      ]
    },
    rules() {
      return {
        name: [{required: true, message: "请填写姓名"}],
        // organizationId: [{required: true, message: "请选择党组织"}],
        // unitId: [{required: true, message: "请选择单位"}],
        // areaId: [{required: true, message: '请选择地区', trigger: 'change'}],
        roleId: [{required: true, message: "请选择角色"}],
        phone: [{required: true, message: "请输入手机号码"}]
      }
    },
    disabledLevel() {
      return this.user.info.areaList?.length || 0
    }
  },
  data() {
    return {
      accountRoles: [],
      page: {pageNum: 1, pageSize: 10, total: 0},
      dialog: false,
      dialogForm: {},
      tableData: [],
      search: {condition: ""},
      ids: []
    }
  },
  methods: {
    getTableData() {
      this.instance.post("/admin/user/page", null, {
        params: {...this.page, ...this.search}
      }).then(res => {
        if (res?.data) {
          this.tableData = res.data?.records
          this.page.total = res.data.total
        }
      })
    },
    initDialogData() {
      //用于优化初始化数据
      this.getAccountRoles()
    },
    getAccountRoles() {
      this.accountRoles.length == 0 && this.instance.post("/admin/role/list-all").then(res => {
        if (res?.data) {
          this.accountRoles = res.data
        }
      })
    },
    batchAllot() {
      this.dialog = true
      this.dialogForm = {areaId: this.user.info.areaId, ids: this.ids}
    },
    appAllot(row) {
      this.dialog = true
      this.dialogForm = JSON.parse(JSON.stringify({
        ...row,
        areaId: row.areaId || this.user.info.areaId
      }));
    },
    // 修改
    updateAccount() {
      this.$refs.updateAccountForm.validate(v => {
        if (v) {
          this.instance.post("/admin/user/addOrEdit", this.dialogForm).then(res => {
            if (res?.code == 0) {
              this.dialog = false;
              this.$message.success("提交成功")
              this.getTableData();
            } else {
              this.$message.error(res?.msg)
            }
          })
        }
      })
    },
    handleDelete(ids) {
      this.$confirm("是否要删除该账号?").then(() => {
        this.instance.post("/admin/user/del", null, {
          params: {ids}
        }).then(res => {
          if (res?.code == 0) {
            this.getTableData();
            this.$message.success("删除成功!");
          }
        })
      }).catch(() => 0)
    },
    handleAreaSelect(v) {
      this.dialogForm.areaName = v?.[0]?.label
    }
  },
  created() {
    this.getTableData()
  }
}
</script>

<style lang="scss" scoped>
.AppSystemAccount {
  height: 100%;

  ::v-deep .avatar {
    width: 40px;
    height: 40px;
    margin-right: 10px;
  }

  ::v-deep .el-form {
    .el-cascader, .el-select {
      width: 100%;
    }
  }
}
</style>
